import { TOOL_API } from '../common/commonModule'
class RestFul {
  constructor(requestClient) {
    this.requestClient = requestClient
    this.moduleName = 'RestFulModule'
  }
  // 处理传入的data 如果有appCode dbName
  packParamHandle (parms) {
    const { appCode } = parms
    if (!appCode) {
      parms.appCode = this.requestClient.appCode //|| urlParam.appCode
    }
  }
  mergeHeaderQueryMaster (isQueryMaster) {
    if (isQueryMaster) {
      return {
        'x-db_router_type': 'master'
      }
    } else {
      return {}
    }
  }
  query (data) {
    this.packParamHandle(data)
    const { tableName, appCode, group, parms, bodyData, isQueryMaster } = data
    let url = `${TOOL_API}${appCode}/${tableName}/`
    if (group) { // 非标准保存
      url = `${url}${group}/`
    }
    const header = this.mergeHeaderQueryMaster(isQueryMaster)
    if (bodyData) {
      return this.requestClient.put(url, bodyData, parms, header)
    } else {
      return this.requestClient.get(url, parms, header)
    }
  }
  save (data) {
    this.packParamHandle(data)
    const { tableName, appCode, bodyData, group, parms } = data
    let url = `${TOOL_API}${appCode}/${tableName}/`
    if (group) { // 非标准保存
      url = `${url}${group}/`
    }
    return this.requestClient.post(url, bodyData, parms)
  }
  queryOne (data) {
    this.packParamHandle(data)
    const { tableName, id, appCode, parms, group, bodyData, isQueryMaster } = data
    let url_ = `${TOOL_API}${appCode}/${tableName}/${id}/`
    if (group) {
      url_ = `${url_}${group}/`
    }
    const header = this.mergeHeaderQueryMaster(isQueryMaster)
    if (bodyData) {
      return this.requestClient.put(url_, bodyData, parms, header)
    } else {
      return this.requestClient.get(url_, parms, header)
    }
  }
  put (data) {
    this.packParamHandle(data)
    const { tableName, appCode, bodyData, group, parms, isQueryMaster } = data
    let url = `${TOOL_API}${appCode}/${tableName}/`
    if (group) { // 非标准保存
      url = `${url}${group}/`
    }
    const header = this.mergeHeaderQueryMaster(isQueryMaster)
    return this.requestClient.put(url, bodyData, parms, header)
  }
  queryList (data) {

    this.packParamHandle(data)
    const { tableName, appCode, parms, group, bodyData, isQueryMaster } = data
    let url_ = `${TOOL_API}${appCode}/${tableName}/`
    if (group) {
      url_ = `${url_}${group}/`
    }
    parms.fuzzy = 1
    const header = this.mergeHeaderQueryMaster(isQueryMaster)
    if (bodyData) {
      return this.requestClient.put(url_, bodyData, parms, header)
    } else {
      return this.requestClient.get(url_, parms, header)
    }
  }
  deleteList (data) {
    this.packParamHandle(data)
    const { tableName, appCode, bodyData, parms } = data
    const url_ = `${TOOL_API}${appCode}/${tableName}/`
    return this.requestClient.delete(url_, bodyData, parms)
  }
}
export default RestFul
